/*
 * Almacen.java
 *
 * Created on 8 de mayo de 2007, 13:09
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package contweb.mvc.modelo;

import java.io.*;
import java.util.*;

public class Almacen {
    private Map libros;
  
    public Almacen(File archivo, char separador) throws IOException {
        System.out.println("Intentando leer " + archivo.getAbsolutePath());
    
        libros = new HashMap();
        BufferedReader br = new BufferedReader(new FileReader(archivo));
        String linea = null;

        //Se lee el archivo lnea a lnea, se crea un libro con cada una y se guardan en la tabla
        while ((linea = br.readLine()) != null) {
            Libro libro = crearLibro(linea, separador);
            libros.put(libro.getId(), libro);
        }
        br.close();
    }
    
    public Libro[] getLibros() {
	//Devuelve todos los libros del almacn.
	return (Libro[])libros.values().toArray(new Libro[libros.size()]);
    }
  
    public Libro getLibro(String id) {
        return (Libro)libros.get(id);
    }

    private Libro crearLibro(String linea, char sep) {
        //Se parte la lnea en funcin de un separador y se crea un libro.
        StringTokenizer st = new StringTokenizer(linea, String.valueOf(sep));

        String id = st.nextToken();
        String nombre = st.nextToken();
        int stock = Integer.parseInt(st.nextToken());

        return new Libro(id, nombre, stock);      
    }
}

